Attribute VB_Name = "basRegistry"
'force variable declaration
Option Explicit


'API external function declarations
Declare Function RegOpenKeyExA Lib "advapi32.dll" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long
Declare Function RegQueryValueExA Lib "advapi32.dll" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long
Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long

'registry constants
Public Const READ_CONTROL = &H20000
Public Const STANDARD_RIGHTS_READ = (READ_CONTROL)
Public Const STANDARD_RIGHTS_WRITE = (READ_CONTROL)
Public Const KEY_QUERY_VALUE = &H1
Public Const KEY_SET_VALUE = &H2
Public Const KEY_CREATE_SUB_KEY = &H4
Public Const KEY_ENUMERATE_SUB_KEYS = &H8
Public Const KEY_NOTIFY = &H10
Public Const KEY_CREATE_LINK = &H20
Public Const SYNCHRONIZE = &H100000
Public Const STANDARD_RIGHTS_ALL = &H1F0000
Public Const KEY_READ = ((STANDARD_RIGHTS_READ Or KEY_QUERY_VALUE Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY) And (Not SYNCHRONIZE))
Public Const KEY_WRITE = ((STANDARD_RIGHTS_WRITE Or KEY_SET_VALUE Or KEY_CREATE_SUB_KEY) And (Not SYNCHRONIZE))
Public Const KEY_ALL_ACCESS = ((STANDARD_RIGHTS_ALL Or KEY_QUERY_VALUE Or KEY_SET_VALUE Or KEY_CREATE_SUB_KEY Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY Or KEY_CREATE_LINK) And (Not SYNCHRONIZE))
Public Const KEY_EXECUTE = ((KEY_READ) And (Not SYNCHRONIZE))


'return registry value
Function sdaGetRegEntry(strKey As String, strSubKeys As String, strValName As String, lngType As Long) As String
   Dim lngcbData As Long
   Dim lngHandle As Long
   Dim lngKey As Long
   Dim lngResult As Long
   Dim strRet As String

   'get root key
   On Error GoTo sdaGetRegEntry_Error
   Select Case strKey
      Case "HKEY_CLASSES_ROOT": lngKey = &H80000000
      Case "HKEY_CURRENT_CONFIG": lngKey = &H80000005
      Case "HKEY_CURRENT_USER": lngKey = &H80000001
      Case "HKEY_DYN_DATA": lngKey = &H80000006
      Case "HKEY_LOCAL_MACHINE": lngKey = &H80000002
      Case "HKEY_PERFORMANCE_DATA": lngKey = &H80000004
      Case "HKEY_USERS": lngKey = &H80000003
      Case Else: Exit Function
   End Select

   'read key and store in string
   If RegOpenKeyExA(lngKey, strSubKeys, 0&, KEY_READ, lngHandle) <> 0 Then Exit Function
   lngResult = RegQueryValueExA(lngHandle, strValName, 0&, lngType, ByVal strRet, lngcbData)
   strRet = Space(lngcbData)
   lngResult = RegQueryValueExA(lngHandle, strValName, 0&, lngType, ByVal strRet, lngcbData)
   If RegCloseKey(lngHandle) <> 0 Then lngType = -1&
   sdaGetRegEntry = strRet
   Exit Function

sdaGetRegEntry_Error:
   lngType = -1
   sdaGetRegEntry = ""
End Function
